% Create Artifical Real Consol Excess Bond Return.
% dataOUT is monthly right now.

function newdataOUT = GetConsolBondRet(dataOUT, PHI0, PHI1, rhoConsol)

[T, n] = size(dataOUT);
e1 = [1, zeros(1,n-1)];

PHI1hat = rhoConsol*PHI1;

Ac  = inv(eye(n)-PHI1hat);

term1 = e1*Ac*PHI0;
term2 = (dataOUT(1:T-1,:)-rhoConsol*dataOUT(2:T,:))*(e1*Ac*PHI1)';
term3 = e1*PHI0 + dataOUT(1:T-1,:)*(e1*PHI1)';

%RealConsolBondRet = term1 + term2 - term3;
%LV modification 8/24/00
RealConsolBondRet = term1 + term2 - dataOUT(2:T,1);
RT = rows(RealConsolBondRet);

% -- Make the Jensen's Ineq adjusted excess return = 0 --%
RealConsolBondRet = RealConsolBondRet-((RT-1)/RT)*cov(RealConsolBondRet(2:RT))/2-mean(RealConsolBondRet(2:RT)) ;
%RealConsolBondRet = RealConsolBondRet-((RT)/RT)*cov(RealConsolBondRet(1:RT))/2-mean(RealConsolBondRet(1:RT)) ;
%mean(RealConsolBondRet(1:RT)) +.5*cov(((RT)/RT)*RealConsolBondRet(1:RT))
mean(RealConsolBondRet(2:RT)) +.5*cov(((RT-1)/RT)*RealConsolBondRet(2:RT))

% -- Replace Nominal Bond Return -- %
newdataOUT = [dataOUT(2:T,1:2), RealConsolBondRet, dataOUT(2:T, 4:n)];






