function y = ReverseVecl(x)

% ReverseVecl() reverse the vecl() operation: x = vecl(y);
%
% x is a n(n+1)/2 vector; y is a nxn matrix with zeros in 
% the upper off-diag triangular part.   
%
% Lewis Chan, April 7, 2001.
%

k = 2*length(x);
n = 1/2*(-1+sqrt(1+4*k));
y = zeros(n);

t1 = 1;
t2 = n;
for i=n:-1:1
   y(n-(i-1):n, n-(i-1)) = x(t1:t2);
   t1 = t1 + i;
   t2 = t2 + (i-1);
end
