% ---- This Program Creates Tex Table: Sample Statistics, Monthly and Annual Data ---- %

% -- User Specifies Info Here -- %
TableName = 'Table_SUMM.tex';
TableDir  = './tables/';
SysId     = 2;

% -- Create Latex Shell -- %
TableName = [TableDir, TableName];
fid = fopen(TableName,'w');
fprintf(fid, '\\documentstyle{article} \n');
fprintf(fid, '\\setlength{\\oddsidemargin}{.25in} \n');
fprintf(fid, '\\setlength{\\textwidth}{5.5in} \n');
fprintf(fid, '\\setlength{\\topmargin}{0.50in} \n');
fprintf(fid, '\\setlength{\\textheight}{9.00in} \n');
fprintf(fid, '\\pagestyle{empty} \n');
fprintf(fid, '\\begin{document} \n');
fprintf(fid, '\\input table \n');
fprintf(fid, '\\BeginTable \n');
fprintf(fid, '\n');
fprintf(fid, '\\def\\C{\\JustCenter} \n');
fprintf(fid, '\\def\\L{\\JustLeft} \n');
fprintf(fid, '\\def\\R{\\JustRight} \n');
fprintf(fid, '\\Expand \n');

% -- Full Sample QTR -- %
load ISV_Q_g0001_pID1_SN__s.mat % must be an N file

meanState1 = (mean(dataOUT(:,1))+0.5*cov(dataOUT(:,1)))*400;
meanState2 = (mean(dataOUT(:,2))+0.5*cov(dataOUT(:,2)))*400;
meanState3 = (mean(dataOUT(:,3))+0.5*cov(dataOUT(:,3)))*400;
meanState4 = mean(dataOUT(:,4))*400;
meanState5 = mean(dataOUT(:,5));
meanState6 = mean(dataOUT(:,6))*400;
stdState1 = std(dataOUT(:,1))*100*sqrt(4);
stdState2 = std(dataOUT(:,2))*100*sqrt(4);
stdState3 = std(dataOUT(:,3))*100*sqrt(4);
stdState4 = std(dataOUT(:,4))*100*sqrt(4);
stdState5 = std(dataOUT(:,5));
stdState6 = std(dataOUT(:,6))*100*sqrt(4);

% -- Annual Data -- %
load ISV_A_g0001_pID1_SN__s.mat % must be an N file

meanState1a = (mean(dataOUT(:,1))+0.5*cov(dataOUT(:,1)))*100;
meanState2a = (mean(dataOUT(:,2))+0.5*cov(dataOUT(:,2)))*100;
meanState3a = (mean(dataOUT(:,3))+0.5*cov(dataOUT(:,3)))*100;
meanState4a = mean(dataOUT(:,4))*100;
meanState5a = mean(dataOUT(:,5));
meanState6a = mean(dataOUT(:,6))*100;
stdState1a = std(dataOUT(:,1))*100;
stdState2a = std(dataOUT(:,2))*100;
stdState3a = std(dataOUT(:,3))*100;
stdState4a = std(dataOUT(:,4))*100;
stdState5a = std(dataOUT(:,5));
stdState6a = std(dataOUT(:,6))*100;

% -- Create Latex Shell -- %
fprintf(fid, '\\BeginFormat \n');
fprintf(fid, '| l | cn[-0.000] | cn[-0.000] | cn[-0.000] | \n');
fprintf(fid, '\\EndFormat \n');
   
fprintf(fid, '" \\use4 \\C \\bf TABLE " \\\\+02 \n');
fprintf(fid, '" \\use4 \\C \\bf Sample Statistics " \\\\+13 \\_3 \n');
   
fprintf(fid, '" \\use2 \\C Sample Moment " \\C 1952Q2 - 1997Q4 " \\C 1890 - 1995  " \\\\+40 \n');
fprintf(fid, '" \\use2 \\- " \\- " \\- " \\\\+00 \n');

	% -- State Var 1 -- %
	fprintf(fid, '"(1) ');
	fprintf(fid, '" \\L $E[r^\\$_{1,t} - \\pi_{t}]+\\sigma^2(r^\\$_{1,t} - \\pi_{t})/2$ ');
	fprintf(fid, '" %4.3f " %4.3f "', meanState1, meanState1a);
   fprintf(fid, '\\\\+11 \n');
   fprintf(fid, '"(2) ');
	fprintf(fid, '" \\L $\\sigma(r^\\$_{1,t} - \\pi_{t})$ ');
	fprintf(fid, '" %4.3f " %4.3f "', stdState1, stdState1a);
	fprintf(fid, '\\\\+15 \n');

	% -- State Var 2 -- %
   fprintf(fid, '"(3) ');
   fprintf(fid, '" \\L $E[r^\\$_{e,t}-r^\\$_{1,t}]+ \\sigma^2(r^\\$_{e,t}-r^\\$_{1,t})/2$ ');
	fprintf(fid, '" %4.3f " %4.3f "', meanState2, meanState2a);
   fprintf(fid, '\\\\+11 \n');
   fprintf(fid, '"(4) ');
	fprintf(fid, '" \\L $\\sigma(r^\\$_{e,t}-r^\\$_{1,t})$ ');
	fprintf(fid, '" %4.3f " %4.3f "', stdState2, stdState2a);
   fprintf(fid, '\\\\+11 \n');
   fprintf(fid, '"(5) ');
	fprintf(fid, '" \\L $SR = (3)/(4)$ ');
	fprintf(fid, '" %4.3f " %4.3f "', meanState2/stdState2, meanState2a/stdState2a);
	fprintf(fid, '\\\\+15 \n');

	% -- State Var 3 -- %
	fprintf(fid, '"(6) ');
	fprintf(fid, '" \\L $E[r^\\$_{n,t}-r^\\$_{1,t}]+ \\sigma^2(r^\\$_{n,t}-r^\\$_{1,t})/2$ ');
	fprintf(fid, '" %4.3f " %4.3f "', meanState3, meanState3a);
   fprintf(fid, '\\\\+11 \n');
   fprintf(fid, '"(7) ');
	fprintf(fid, '" \\L $\\sigma(r^\\$_{n,t}-r^\\$_{1,t})$ ');
	fprintf(fid, '" %4.3f " %4.3f "', stdState3, stdState3a);
   fprintf(fid, '\\\\+11 \n');
   fprintf(fid, '"(8) ');
	fprintf(fid, '" \\L $SR = (6)/(7)$ ');
	fprintf(fid, '" %4.3f " %4.3f "', meanState3/stdState3, meanState3a/stdState3a);
	fprintf(fid, '\\\\+15 \n');

	% -- State Var 4 -- %
   fprintf(fid, '"(9) ');
   fprintf(fid, '" \\L $E[y^\\$_{t}]$ ');
	fprintf(fid, '" %4.3f " %4.3f "', meanState4, meanState4a);
   fprintf(fid, '\\\\+11 \n');
   fprintf(fid, '"(10) ');
	fprintf(fid, '" \\L $\\sigma(y^\\$_{t})$ ');
	fprintf(fid, '" %4.3f " %4.3f "', stdState4, stdState4a);
	fprintf(fid, '\\\\+15 \n');

	% -- State Var 5 -- %
   fprintf(fid, '"(11) ');
   fprintf(fid, '" \\L $E[d_t-p_t]$ ');
	fprintf(fid, '" %4.3f " %4.3f "', meanState5, meanState5a);
   fprintf(fid, '\\\\+11 \n');
   fprintf(fid, '"(12) ');
	fprintf(fid, '" \\L $\\sigma(d_t-p_t)$ ');
	fprintf(fid, '" %4.3f " %4.3f "', stdState5, stdState5a);
	fprintf(fid, '\\\\+15 \n');

	% -- State Var 6 -- %
   fprintf(fid, '"(13) ');
   fprintf(fid, '" \\L $E[y^\\$_{n,t} - y^\\$_{1,t}]$ ');
	fprintf(fid, '" %4.3f " %4.3f "', meanState6, meanState6a);
   fprintf(fid, '\\\\+11 \n');
   fprintf(fid, '"(14) ');
	fprintf(fid, '" \\L $\\sigma(y^\\$_{n,t} - y^\\$_{1,t})$ ');
	fprintf(fid, '" %4.3f " %4.3f "', stdState6, stdState6a);
	fprintf(fid, '\\\\+13 \n');


fprintf(fid, '\\\\+00 \\_3 \n');


% -- Finish Tex Table Format -- %
fprintf(fid, '\\EndTable \n');


fprintf(fid, '\\bigskip \\footnotesize{\\bf Note}: $r_{1,t}^\\$ $ = log return on T-bills, ');
fprintf(fid, '$\\pi_t$ = log inflation rate, $r_{e,t}^\\$ $ = log return on equities, ');
fprintf(fid, '$r_{n,t}^\\$$ = log return on nominal bond, ');
fprintf(fid, '$(d-p)_t$ = log dividend-price ratio, $rb_t$ = relative bill rate, ');
fprintf(fid, '$y_{n,t}^\\$$ = log yield on the nominal bond, and $y_{1,t}^\\$$ is the short yield. ');
fprintf(fid, 'The bond is a 5-year nominal bond in the quarterly dataset and a 20-year for the annual dataset. \\normalsize');



fprintf(fid, '\\end{document} \n');
status = fclose(fid);
