%Calculate variances as function of maturity

e_rf   = [1 0 0 0 0 0]';
e_xe   = [0 1 0 0 0 0]';
e_xb   = [0 0 1 0 0 0]';
e_rf_d = [0 0 0 1 0 0]';


A = PHI1;
Omega = SIGMAv;

max_mat = 100
IA_factor = zeros(rows(A),cols(A),max_mat);
IA_factor(:,:,1) = eye(rows(A));
for i = 2:max_mat
   IA_factor(:,:,i) = IA_factor(:,:,i-1) + A^(i-1);
end
%form Sigma_H, Sigma_Zk, Cov_H_Zk
Sigma_H  = zeros(rows(A),cols(A),max_mat);
Sigma_Zk = zeros(rows(A),cols(A),max_mat);
Cov_H_Zk = zeros(rows(A),cols(A),max_mat);

Sigma_H(:,:,1)  = IA_factor(:,:,1)*Omega*IA_factor(:,:,1);
Sigma_Zk(:,:,1) = A^(1-1)*Omega*A^(1-1)';
%Cov_H_Zk(:,:,1) = IA_factor(:,:,1)*Omega*A^(i-1)';
Cov_H_Zk(:,:,1) = IA_factor(:,:,1)*Omega*A';

for i = 2:max_mat
   Sigma_H(:,:,i)  = Sigma_H(:,:,i-1)  + IA_factor(:,:,i)*Omega*IA_factor(:,:,i)';
   Sigma_Zk(:,:,i) = Sigma_Zk(:,:,i-1) + A^(i-1)*Omega*A^(i-1)';
   %Cov_H_Zk(:,:,i) = Cov_H_Zk(:,:,i-1) + IA_factor(:,:,i-1)*Omega*A^(i-1)';
   Cov_H_Zk(:,:,i) = Cov_H_Zk(:,:,i-1) + IA_factor(:,:,i)*Omega*A^(i)';
end

var_rf = zeros(max_mat,1);
var_eq = zeros(max_mat,1);
var_bo = zeros(max_mat,1);
var_bo_h = zeros(max_mat,1);

% YLC:
for k = 1:max_mat
   
   var_rf(k)   = (e_rf)'*Sigma_H(:,:,k)*(e_rf);

   %var_eq(k)   = (e_xe+e_rf)'*Sigma_H(:,:,k-1)*(e_xe+e_rf);
   %var_bo(k)   = (e_xb+e_rf)'*Sigma_H(:,:,k-1)*(e_xb+e_rf);

   %var_bo_h(k) = (e_rf_d-e_rf)'*Sigma_H(:,:,k-1)*(e_rf_d-e_rf) ...
   %            + (e_rf)'*Sigma_Zk(:,:,k)*(e_rf) ...
   %            + 2*(e_rf_d-e_rf)'*Cov_H_Zk(:,:,k)*(e_rf);
   
   var_eq(k)   = (e_xe+e_rf)'*Sigma_H(:,:,k)*(e_xe+e_rf);
   var_bo(k)   = (e_xb+e_rf)'*Sigma_H(:,:,k)*(e_xb+e_rf);
   
   if k == 1
      var_bo_h(k) = (e_rf)'*Sigma_H(:,:,k)*(e_rf);
   else
      var_bo_h(k) = (e_rf_d-e_rf)'*Sigma_H(:,:,k-1)*(e_rf_d-e_rf) ...
               	+ (e_rf)'*Sigma_Zk(:,:,k)*(e_rf) ...
                  - 2*(e_rf_d-e_rf)'*Cov_H_Zk(:,:,k-1)*(e_rf);  
   end         
end
