%%-------------------------------------------------------------------------
% Main code for chapter 6: multivariate time-series
%--------------------------------------------------------------------------

% -------------- Room saving ----------------------------------------------

close all; clear all; clc; pause(0.01), randn('seed',sum(clock)), rand('seed',sum(clock)), warning off
TSTART = tic;
% -------------- Load folders ---------------------------------------------

addpath([pwd '\Input\']);
addpath([pwd '\Utilities\']);
addpath([pwd '\Output\']);

% -------------- Import data  and transform -------------------------------
[data,textdata,raw] = xlsread('STOCKINT2013.xls','Quarterly');
%[filename,pathname]=uigetfile('*.xls');
%[data,textdata,raw] = xlsread(filename,'Monthly');

%Convert dates into a serial number
date=datenum(textdata(4:end,1),'dd/mm/yyyy');

run ch6_datatran
%--------------------------------------------------------------------------
% SECTION 1: Stochastic Trends and Spurious Regressions
%--------------------------------------------------------------------------
run ch6_section1 
%--------------------------------------------------------------------------
% SECTION 2: Dynamic Models and Spurious Regressions
%--------------------------------------------------------------------------
run ch6_section2 
%--------------------------------------------------------------------------
% SECTION 3: Spurious Regressions and the predictability of returns 
%--------------------------------------------------------------------------
run ch6_section3
%--------------------------------------------------------------------------
% SECTION 4: Cointegration with Multiple Vectors 
%--------------------------------------------------------------------------
run ch6_section4
%--------------------------------------------------------------------------
% SECTION 5: Cochrane(1994) 
%--------------------------------------------------------------------------  
run ch6_section5
tElapsed = toc(TSTART);
display(['The time needed to run the code is: ',num2str(tElapsed/60),' minutes']);         








