     
%--------------------------------------------------------------------------
% SECTION 1: Stochastic Trends and Spurious Regressions
%--------------------------------------------------------------------------
    
date=datenum(textdata(4:end,1),'dd/mm/yyyy');
f1=['31/03/1974'];
f2=['31/12/2011'];
date_find1=datenum(f1,'dd/mm/yyyy');
date_find2=datenum(f2,'dd/mm/yyyy');
first=datefind(date_find1,date);
last=datefind(date_find2,date);
t=1:rows(US.p);
%----------------------------------------------------------------------
% STATIC REGRESSIONS 
%----------------------------------------------------------------------
LP=NaN(rows(US.p),2);
LP(:,1)=US.lp;
LP(:,2)=UK.lp;

X2=NaN(rows(US.p),3);
X2(:,1)=US.ldiv(:,1);
X2(:,2)=UK.ldiv(:,1);
%X2(:,3)=US.MY(:,1);

country=strvcat('US_div','UK_div');

for i=1:2

X=NaN(rows(US.p),2);
X(:,1)=ones;
X(:,2)=X2(:,i);
%X(:,3)=X2(:,3);

result=ols(LP(first:last,2), X(first:last,:));
var1=strcat('result',(country(i,:)));
assignin('base',var1,result);
end
clear var1 result

 %plot residuals 
residUK_div=resultUK_div.resid;
residUS_div=resultUS_div.resid;
    t=1:rows(US.p); 
    figure
    h1=plot(t(:,first:last)',residUK_div,t(:,first:last)',residUS_div,'-','LineWidth',2);
    title(' Residuals from Static Regressions','fontname','garamond','fontsize',16);
     set(gca,'fontname','garamond','fontsize',12);
     set(gca,'xtick',[1:8:rows(t')]); 
     set(gca,'xlim',[1 rows(t')]);
    set(gca,'xticklabel','1973|1975|1977|1979|1981|1983|1985|1987|1989|1991|1993|1995|1997|1999|2001|2003|2005|2007|2009|2011');
    grid;
    set(gcf,'color','w');
    h1=legend('UKdiv','USdiv',0);
   
%----------------------------------------------------------------------
% AUTOREGRESSIVE MODEL 
%----------------------------------------------------------------------    
spec=garchset('VarianceModel','Constant', 'R', 1);
[coeffuk_lp,erruk_lp,llf,innovation,sigma,summary]= garchfit(spec,UK.lp(first:last,:));
garchdisp(coeffuk_lp,erruk_lp);  
[coeffus_ld,errus_ld,llf,innovation,sigma,summary]= garchfit(spec,US.ldiv(first:last,:));
garchdisp(coeffus_ld,errus_ld);
[coeffuk_ld,erruk_ld,llf,innovation,sigma,summary]= garchfit(spec,UK.ldiv(first:last,:));
garchdisp(coeffuk_ld,erruk_ld);
