% ------------------------------------- */
% dosim: calculates responses to shocks */
% ------------------------------------- */

   Dxsim = zeros(horiz,nseries);                   % setup: differences     */
   xsim = Dxsim;                                   % levels                 */

   % t=1 levels and diffs  */

   compan = zeros(cols(a)+lags*nseries,1);         % last period's state    */
   vshock = zeros(nseries,1);
   vshock(shock) = 1;                              % unit shock             */
   Dxsim(1,:) =  (r*vshock)';                      % e shock equal to v shk */
   xsim(1,:) =  Dxsim(1,:);

   % ---------------------- */
   % simulate resp to shock */
   % ---------------------- */

   i = 2;
   while i <= horiz;

      % ------------------------------------------ */
      % update compan (compan is conformable to b) */
      % ------------------------------------------ */

      compan(2+cols(a):rows(compan)) =   ...          % shift down 
                 compan(1+cols(a):rows(compan)-1);
      compan(1:cols(a)) = (a'*(xsim(i-1,:)')) ;       % new lagged ci vector  
      j = 1;                                          % new lagged Dx(t)'s    
      while j <= nseries;
        compan(1+cols(a)+(j-1)*lags) = Dxsim(i-1,j);
        j = j+1;
      end;

      % ------------- */
      % generate Dx,x */
      % ------------- */

      Dxsim(i,:) = (b(2:rows(b),:)'*compan)' ;
      xsim(i,:)  = xsim(i-1,:) +  Dxsim(i,:);

      i = i+1;
   end;
