function [newdelta,A0,A1,b0,B1,vecB2B2] = GetNewDelta(rho,b0,B1,vecB2B2,tmpb0,tmpB1,tmpvecB2B2,PHI0,PHI1,SIGMAv,Hx,H1,psi,gama,delta,g,CritValB)

global CVG_CHECK;

% -- Parameters -- % 
n = rows(Hx)+1;							% number of assets, including short-term instrument %
m = rows(PHI0);							% m = number of state variables %
iota = ones(n-1,1);
theta = (1-gama)/(1-(1/psi));
k = log(rho)+(1-rho)*log(1-rho)/rho;
							
% -- Partition the Covariance matrix -- %
%size(SIGMAv)
%size(Hx)
%size(H1)
%Hx
%H1

SIGMA1x = Hx*SIGMAv*H1';
SIGMAxx = Hx*SIGMAv*Hx';
sigma11 = SIGMAv(1,1);
d = diag(SIGMAxx);
VARvv = GetVARvv(SIGMAv,m);

% -- Get (b0,B1,B2) and (A0,A1) to Converge, for a Given Rho -- %
znew = ConvergeB(b0,B1,vecB2B2,tmpb0,tmpB1,tmpvecB2B2);
zmat = [ones(g-1,1); znew];
z = sum(zmat);
count = 0;
while (z > CritValB) & (count < 3000)
	count = count+1;
	if round(count/100)*100==count
		disp([count z])
	end

	% for debugging purposes. JW
%   	CVG_CHECK=[CVG_CHECK; b0 B1' vecB2B2'];

	B2B2 = GetB2B2(vecB2B2);
	if B2B2(2,2) ~= 0
%	disp('B2B2');
%	disp(B2B2);
%	disp('GAMMA2');
%	disp(reshape(GAMMA2,m,m));
%	disp('A1prime*Hx*PHI1');
%	disp(A1'*Hx*PHI1);
%	disp('V2');
%	disp(reshape(V2,m,m));
%	disp('LAMDA1prime*Hx*PHI1');
%	disp(LAMDA1'*Hx*PHI1);
	end
   
	% ---- Coefficient Matrices ---- %
	LAMDA0 = (SIGMAv*Hx')'*B1 + 2*(SIGMAv*Hx')'*.5*(B2B2+B2B2')*PHI0;
	LAMDA1 = 2*(SIGMAv*Hx')'*.5*(B2B2+B2B2')*PHI1;

	A0 = (1/gama)*inv(SIGMAxx)*(Hx*PHI0+(1/2)*d-(theta/psi)*LAMDA0+(1-gama)*SIGMA1x);
	A1 = (1/gama)*inv(SIGMAxx)*(Hx*PHI1-(theta/psi)*LAMDA1);
   
	GAMMA0 = A0'*Hx*PHI0 + H1*PHI0 + (1/2)*A0'*d - (1/2)*A0'*SIGMAxx*A0;
	GAMMA1 = PHI0'*Hx'*A1 + A0'*Hx*PHI1 + H1*PHI1 + (1/2)*d'*A1 - A0'*SIGMAxx*A1;
	GAMMA2 = vec(A1'*Hx*PHI1)' - (1/2)*vec(A1'*SIGMAxx*A1)' ;
   
	PI1 = B1'+(1-psi)*A0'*Hx+(1-psi)*H1+2*PHI0'*.5*(B2B2+B2B2');
	PI2 = 2*(PHI1'*.5*(B2B2+B2B2'))+(1-psi)*A1'*Hx;
	V0  = (theta/(2*psi))*( PI1*SIGMAv*PI1'+vecB2B2'*VARvv*vecB2B2 );
	V1  = (theta/(2*psi))*(2*PI1*SIGMAv*PI2');
	V2  = (theta/(2*psi))*vec(PI2*SIGMAv*PI2')';
   
	XI0 = rho*(-psi*log(delta) + k - V0 + (1-psi)*GAMMA0 + b0 + B1'*PHI0 + vecB2B2'*vec(PHI0*PHI0') + vecB2B2'*vec(SIGMAv));
	XI1 = rho*(-V1 + (1-psi)*GAMMA1 + B1'*PHI1 + 2*PHI0'*.5*(B2B2+B2B2')*PHI1 );
	XI2 = rho*(-V2 + (1-psi)*GAMMA2 + vec(PHI1'*B2B2*PHI1)');
   
   % -- Updating -- %
	tmpb0 = b0;
	tmpB1 = B1;
	tmpvecB2B2 = vecB2B2;
	b0 = XI0;
	B1 = XI1';
   vecB2B2 = XI2';
   znew = ConvergeB(b0,B1,vecB2B2,tmpb0,tmpB1,tmpvecB2B2);
   %disp([B1 tmpB1]);
   zmat = [zmat(2:rows(zmat)); znew];
   z = sum(zmat);
   %fprintf('z');fprintf('%6.2f\n',z);   
end;		% End of z-loop for B's.
%disp('count');
%disp(count);
%disp(zmat);
% -- Calculate New Rho -- %
muState = inv(eye(rows(PHI0))-PHI1)*PHI0;
sigmaState = reshape(inv(eye((rows(PHI1))^2)-kron(PHI1,PHI1))*SIGMAv(:),m,m);

% -- Calculate the implied delta -- %
term1 = log(1-rho) - B1'*muState - vecB2B2'*vec(sigmaState + muState*muState');
term2 = k - V0 + (1-psi)*GAMMA0 + b0 + B1'*PHI0 + vecB2B2'*vec(PHI0*PHI0') + vecB2B2'*vec(SIGMAv);
term3 = term1 - rho*term2;
newdelta = exp(term3/(-rho*psi));
if count >= 3000
	newdelta = -999;
end
