% declare a global variable that will be used to check convergence
global CVG_CHECK

% -- Initialize matrices -- %
Ealpha_mat = zeros(rows(Hx),m+1); Ealpha_stock_mat = zeros(1,m+1); Ealpha_rbond_mat = zeros(1,m+1); Ealpha_nbond_mat = zeros(1,m+1);
Cash_mat = zeros(1,m+1);
hedgeD_mat = zeros(rows(Hx),m+1);
myopicD_stock_mat = zeros(1,m+1); myopicD_nbond_mat = zeros(1,m+1); myopicD_rbond_mat = zeros(1,m+1); 
hedgeD_stock_mat = zeros(1,m+1); hedgeD_nbond_mat = zeros(1,m+1); hedgeD_rbond_mat = zeros(1,m+1); hedgeD_cash_mat = zeros(1,m+1);
HedgeRatio_stock_mat = zeros(1,m+1); HedgeRatio_nbond_mat = zeros(1,m+1); HedgeRatio_rbond_mat = zeros(1,m+1);

% -- Initialize 3D arrays for storing intermediate results -- %
SIGMAv__ = zeros(m,m,m+1);
muState__ = zeros(m,1,m+1);
SIGMAxx__ = zeros(min(size(Hx)),min(size(Hx)),m+1);
SIGMAxx_inv__ = zeros(min(size(Hx)),min(size(Hx)),m+1);
LAMDA0__ = zeros(min(size(Hx)),1,m+1);
LAMDA1__ = zeros(min(size(Hx)),m,m+1);
b0__ = zeros(1,1,m+1);
B1__ = zeros(m,1,m+1);
PHI0__ = zeros(m,1,m+1);
PHI1__ = zeros(m,m,m+1);
B2B2__ = zeros(m,m,m+1);
vecB2B2__ = zeros(m*m,1,m+1);
tPHI0__ = zeros(m,1,m+1);
tPHI1__ = zeros(m,m,m+1);
Rsqvec__ = zeros(m,1,m+1);
CorrResid__ = zeros(m,m,m+1);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Beginning of loop over state variables

for NumState=0:1:m


	% Calculates VAR with restriction that implied steady-state mean of VAR is equal to the 
	% means of the state variables.  Uses only the first NumState state variables

%	if ~isempty(RCBposition)
		% Note: we run GetParmsNumState if there is a real consol bond present
		% RCBposition is determined (automatically) in the batch program.
		[PHI0,PHI1,tPHI0,tPHI1,SIGMAv,Rsqvec,CorrResid] = GetParmsNumState(dataOUT,1,0,1,NumState,RCBposition);
		%Tests for QJE, together with N__ setup.
		%PHI1(1,:) = 0;
		%PHI1(:,1:2) = 0;
		%SIGMAv(1,:) = 0;
		%SIGMAv(:,1) = 0;
%	else
		% Otherwise, we run the version of GetParms that is "standard" -- that is, does
		% not deal with the real consol bond state variable as a special case.
%		[PHI0,PHI1,SIGMAv,CorrResid] = GetParms_ISV_NB(dataOUT,1,0,1,NumState);
		% WHY IS THIS COMMENTED OUT?
%	end	

	% Display results for in-process checking
	disp('NumState, Gamma');
	disp([NumState gamavec]);
	disp('PHI1');
	disp(PHI1);

	% -- Calculate Implied Means/Cov-Var of the State Variables from the VAR -- %
	muState = inv(eye(rows(PHI0)) - PHI1)*PHI0;
	sigmaState = reshape(inv(eye((rows(PHI1))^2)-kron(PHI1,PHI1))*SIGMAv(:),rows(PHI0),rows(PHI0));
   
	% ---- Calculations ---- %
	for i=1:rows(gamavec)		% as currently programmed, gamavec has size (1,1) and this loop only runs once

   		gama = gamavec(i);
   

		% Set psi to the appropriate value.  PSIVALUE, used below, is set in batch.m
		if gama == 1
			psi = PSIVALUE;		% If gamma is 1, then set psi equal to the value intended to approximate 1.
						% This is our mechanism for dealing with the log case.  Since we never publish results
						% for the case gamma = 1, psi <> 1, this works.
		else
      			if psiID == 1
      				psi = PSIVALUE;	% If gamma is not 1, and psi is supposed to be approximately 1, ...
   			elseif psiID == 2
%      				psi = 1/gama;	% If gamma is not 1, and psi is supposed to be the reciprocal (for power utility) ...
      				psi = PSIVALUE_2;	
      			end;
   		end;
   

   		for j=1:rows(rhovec)	% again, as currently programmed, rhovec has size (1,1) and this loop only runs once
      			rho = rhovec(j);
			if (psiID == 1) | (gama == 1)	% psi = 1.  This part is used for a quick look of asset allocation.
						% There is no searching over deltas in this section

				delta = rho;	% Analytically true in the psi = 1 case

				% Initial values for the consumption rule coefficients
				% Formerly started at zero, now start at values specified by GetBstart.
      			   		b0 = 1*(0);
					B1 = ones(cols(H1),1)*(0);
					vecB2B2 = ones(cols(H1)^2,1)*(0);
					%[b0 B1 vecB2B2] = GetBstart(AQ,GV,psiID,AU);

				% Seed randomization
				rand('state',sum(100*clock))

				% Set comparison values for initial convergence test
				tmpb0 = b0 + 1;
				tmpB1 = B1 + 1;
				tmpvecB2B2 = vecB2B2 + 1;

				% Set starting value for B2B2 to be symmetric (not strictly needed)
				tmpvecB2B2=vec(Symmetrize(ReverseVecl(vecl(reshape(tmpvecB2B2,cols(H1),cols(H1))))));

				% Executes step 2 in Appendix B.
				[newdelta,A0,A1,newb0,newB1,newvecB2B2] = GetNewDelta(rho,b0,B1,vecB2B2,tmpb0,tmpB1,tmpvecB2B2,PHI0,PHI1,SIGMAv,Hx,H1,psi,gama,delta,g,CritValB);
    		  		b0 = newb0;
	 	     		B1 = newB1;
		 		vecB2B2 = newvecB2B2;

				ImpliedDelta = rho;
				ImpliedDelta_mat(i+1,j+1) = ImpliedDelta;     
         
   			else;		% psi = 1/gamma.
         
         			% -- Specify Initial Values -- %
				b0 = 0;
				B1 = zeros(cols(H1),1);
				vecB2B2 = zeros(cols(H1)^2,1);
				rand('state',sum(100*clock))
				tmpb0 = randn(1,1);
				tmpB1 = randn(cols(H1),1);
				tmpvecB2B2 = randn(cols(H1)^2,1);
         
				test2 = 1;         
				if test2 == 1	

					% -- Iteration to rho -- %

					%rho = delta;	% starting value for rho
					rho = .97;	% starting value for rho
					delta = deltaORIG;
					if SampleFreq == 2
						delta = deltaORIG^(1/4);
					end
					rhoold = rho + 1;
					%while (abs(newdelta - delta) > CritValDelta) | (abs(rhoold - rho) > CritValDelta)
					ci = 0;
					innererror=0;
					while ((abs(rhoold - rho) > CritValDelta/100) | (abs(1 - rho) < CritValDelta/100))&(ci<40)&(innererror==0)
						ci = ci+1;
						if(exist('newdelta'))
							disp([ci rho newdelta])
						end
						rhoold = rho;
						[newdelta,A0,A1,newb0,newB1,newvecB2B2] = GetNewDelta(rho,b0,B1,vecB2B2,tmpb0,tmpB1,tmpvecB2B2,PHI0,PHI1,SIGMAv,Hx,H1,psi,gama,delta,g,CritValB);
						newdelta
						if newdelta == -999
							disp('too many inner loops')
							innererror = 1;
						end
						vecSIGzz = inv( eye(m^2) - kron(PHI1,PHI1) )*vec(SIGMAv);
						rho = 1 - exp( newb0 + newB1'*muState + newvecB2B2'*( vecSIGzz + vec(muState*muState') ) );
					end
					if (ci>=40)|innererror
						disp('too many outer loops');
						newdelta = zeros(size(newdelta));
						A0 = zeros(size(A0)); A1 = zeros(size(A1));
						newb0 = zeros(size(newb0)); newB1 = zeros(size(newB1));
						newvecB2B2 = zeros(size(newvecB2B2));
					end


				end %test2
         
				b0 = newb0;
				B1 = newB1;
				vecB2B2 = newvecB2B2;
       	
			end;		% End of (if psi...)-Condition.
      
      
			%%%% ---- Compute Various Statistics/Results, e.g. E(c-w) ---- %%%%
			ComputeStatistics;
                  
			% -- Store results which will be processed by processtotex.m to be put into tables

			Ealpha_mat(:,NumState+1) = Ealpha;
			MyopicD_mat(:,NumState+1) = myopicD;
			hedgeD_mat(:,NumState+1) = hedgeD;
			HedgeRatio_mat(:,NumState+1) = HedgeRatio;

		end;		% End of Loop for rhovec.
	end;		% End of Loop for Gamavec.


	% Store intermediate results
	SIGMAv__(:,:,NumState+1) = SIGMAv;
	muState__(:,:,NumState+1) = muState;
	SIGMAxx__(:,:,NumState+1) = Hx*SIGMAv*Hx';
	SIGMA1x__(:,:,NumState+1) = SIGMA1x';
	SIGMAxx_inv__(:,:,NumState+1) = inv(Hx*SIGMAv*Hx');
	LAMDA0__(:,:,NumState+1) = LAMDA0;
	LAMDA1__(:,:,NumState+1) = LAMDA1;
	b0__(:,:,NumState+1) = b0;                
	B1__(:,:,NumState+1) = B1;
	B2B2__(:,:,NumState+1) = B2B2;
	vecB2B2__(:,:,NumState+1) = vecB2B2; 
	PHI0__(:,:,NumState+1) = PHI0;
	PHI1__(:,:,NumState+1) = PHI1;

	tPHI0__(:,:,NumState+1) = tPHI0;
	tPHI1__(:,:,NumState+1)	= tPHI1;
	Rsqvec__(:,:,NumState+1) = Rsqvec;
	CorrResid__(:,:,NumState+1) = CorrResid;



	%cvg_check__(1:size(CVG_CHECK,1),:,NumState+1) = CVG_CHECK;




	% Compute value function and store results
	valuefunction3;
	VF(NumState+1)=EV;
	VFm(NumState+1)=V_mu_z;


end;	% End of Loop for NumState
