% ---- Create Latex Tables for ISV_CB  ---- %

% -- User Specifies Info Here -- %
TableDir  = './tables/';

% -- Create Latex Shell -- %
extTableName = [TableDir, TableName];
fid = fopen(extTableName,'w');
fprintf(fid, '\\documentclass{article} \n');
fprintf(fid, '\\setlength{\\oddsidemargin}{.25in} \n');
fprintf(fid, '\\setlength{\\textwidth}{5.5in} \n');
fprintf(fid, '\\setlength{\\topmargin}{0.50in} \n');
fprintf(fid, '\\setlength{\\textheight}{9.00in} \n');
fprintf(fid, '\\pagestyle{empty} \n');
fprintf(fid, '\\begin{document} \n');
fprintf(fid, '\\input table \n');
fprintf(fid, '\\BeginTable \n');
fprintf(fid, '\n');
fprintf(fid, '\\def\\C{\\JustCenter} \n');
fprintf(fid, '\\def\\L{\\JustLeft} \n');
fprintf(fid, '\\def\\R{\\JustRight} \n');
%fprintf(fid, '\\Expand \n');

% -- Full Sample Results -- %
load(File1);		% Monthly data.

	%numState = cols(H1);
numState = 1;	%Magic number; but to make this flexible would be a real pain in the ass
repState = [1 8];
nameState = char('~~$spr_{t}$');
   
   fprintf(fid, '\\BeginFormat \n');
   fprintf(fid, '|   l   | cn[-0.00] | cn[-0.00] | \n');
   fprintf(fid, '\\EndFormat \n');
   
   fprintf(fid, '" \\use3 \\C \\bf TABLE " \\\\+02 \n');
   fprintf(fid, '" \\use3 \\C \\bf Influence of State Variables on Asset Demands " \\\\+11 \\_3 \n');
   fprintf(fid, '" \\use3 \\C \\bf Nominal Bills, Stocks, Real Consol Bond and Nominal Bond " \\\\+11 \\_3 \n');

 fprintf(fid, '" \\C State Variables: " \\C Constant " \\C Full VAR " \\\\+23 \\_2 \n');
   
   % ---- Gamma = LO ---- %
   if AQ == 'Q'
   	fprintf(fid, '" \\use3 \\L 1953/Q2 - 1999/Q4, Quarterly " \\\\+42 \n');
   else %'A'
 	fprintf(fid, '" \\use3 \\L 1890 - 1998, Annual " \\\\+42 \n');
   end

if psiID == 1
	if AQ == 'A'
		paramstr = strcat('" \ \\L $~\\gamma = ',num2str(gamavec),', \\psi = 1, \\rho = ',num2str(rhovec),'  $ " {} " {} " \\\\+34 \n');
	else
		paramstr = strcat('" \ \\L $~\\gamma = ',num2str(gamavec),', \\psi = 1, \\rho = ',num2str(rhovec^4),'^{1/4}  $ " {} " {} " \\\\+34 \n');
	end
else
	if AQ == 'A'
		paramstr = strcat('" \ \\L $~\\gamma = ',num2str(gamavec),', \\psi = 1/\\gamma, \\rho = ',num2str(rhovec),'  $ " {} " {} " \\\\+34 \n');
	else
		paramstr = strcat('" \ \\L $~\\gamma = ',num2str(gamavec),', \\psi = 1/\\gamma, \\rho = ',num2str(rhovec^4),'^{1/4}  $ " {} " {} " \\\\+34 \n');
	end
end

   fprintf(fid, paramstr);
   
   % -- Stock -- %
   fprintf(fid, '" ');
   fprintf(fid, '~~Stock');
   for j=1:numState+1
      fprintf(fid, ' " %4.2f ', Ealpha_stock_mat(1,repState(j)));
   end      
   fprintf(fid, '" \\\\+11 \n');         
   
   % -- Bond Real-- %
   fprintf(fid, '" ');
   fprintf(fid, '~~Real Bond');
   for j=1:numState+1
      fprintf(fid, ' " %4.2f ', Ealpha_rbond_mat(1,repState(j)));
   end      
   fprintf(fid, '" \\\\+11 \n');         

   % -- Bond Nominal -- %
   fprintf(fid, '" ');
   fprintf(fid, '~~Nominal Bond');
   for j=1:numState+1
      fprintf(fid, ' " %4.2f ', Ealpha_nbond_mat(1,repState(j)));
   end      
   fprintf(fid, '" \\\\+11 \n');         

   % -- Cash -- %
   fprintf(fid, '" ');
   fprintf(fid, '~~Cash');
   for j=1:numState+1
      fprintf(fid, ' " %4.2f ', Cash_mat(1,repState(j)));
   end      
   fprintf(fid, '" \\\\+15 \\_1 \n'); 

   
load(File2);
   
   % ---- Gamma = HI ---- %
if psiID == 1
	if AQ == 'A'
		paramstr = strcat('" \\use3 \\L $~\\gamma = ',num2str(gamavec),', \\psi = 1, \\rho = ',num2str(rhovec),'  $ " \\\\+34 \n');
	else
		paramstr = strcat('" \\use3 \\L $~\\gamma = ',num2str(gamavec),', \\psi = 1, \\rho = ',num2str(rhovec^4),'^{1/4}  $ " \\\\+34 \n');
	end
else
	if AQ == 'A'
		paramstr = strcat('" \\use3 \\L $~\\gamma = ',num2str(gamavec),', \\psi = 1/\\gamma, \\rho = ',num2str(rhovec),'  $ " \\\\+34 \n');
	else
		paramstr = strcat('" \\use3 \\L $~\\gamma = ',num2str(gamavec),', \\psi = 1/\\gamma, \\rho = ',num2str(rhovec^4),'^{1/4}  $ " \\\\+34 \n');
	end
end

   fprintf(fid, paramstr);
   
   % -- Stock -- %
   fprintf(fid, '" ');
   fprintf(fid, '~~Stock');
   for j=1:numState+1
      fprintf(fid, ' " %4.2f ', Ealpha_stock_mat(1,repState(j)));
   end      
   fprintf(fid, '" \\\\+11 \n');         
   
   % -- Bond Real-- %
   fprintf(fid, '" ');
   fprintf(fid, '~~Real Bond');
   for j=1:numState+1
      fprintf(fid, ' " %4.2f ', Ealpha_rbond_mat(1,repState(j)));
   end      
   fprintf(fid, '" \\\\+11 \n');         

   % -- Bond Nominal -- %
   fprintf(fid, '" ');
   fprintf(fid, '~~Nominal Bond');
   for j=1:numState+1
      fprintf(fid, ' " %4.2f ', Ealpha_nbond_mat(1,repState(j)));
   end      
   fprintf(fid, '" \\\\+11 \n');         

   % -- Cash -- %
   fprintf(fid, '" ');
   fprintf(fid, '~~Cash');
   for j=1:numState+1
      fprintf(fid, ' " %4.2f ', Cash_mat(1,repState(j)));
   end      
   fprintf(fid, '" \\\\+15 \\_1 \n'); 
   
load(File3);		% Annual data.

	% ---- Gamma = LO ---- %
if psiID == 1
	if AQ == 'A'
		paramstr = strcat('" \\use3 \\L $~\\gamma = ',num2str(gamavec),', \\psi = 1, \\rho = ',num2str(rhovec),'  $ " \\\\+34 \n');
	else
		paramstr = strcat('" \\use3 \\L $~\\gamma = ',num2str(gamavec),', \\psi = 1, \\rho = ',num2str(rhovec^4),'^{1/4}  $ " \\\\+34 \n');
	end
else
	if AQ == 'A'
		paramstr = strcat('" \\use3 \\L $~\\gamma = ',num2str(gamavec),', \\psi = 1/\\gamma, \\rho = ',num2str(rhovec),'  $ " \\\\+34 \n');
	else
		paramstr = strcat('" \\use3 \\L $~\\gamma = ',num2str(gamavec),', \\psi = 1/\\gamma, \\rho = ',num2str(rhovec^4),'^{1/4}  $ " \\\\+34 \n');
	end
end


   fprintf(fid, paramstr);
   
   % -- Stock -- %
   fprintf(fid, '" ');
   fprintf(fid, '~~Stock');
   for j=1:numState+1
      fprintf(fid, ' " %4.2f ', Ealpha_stock_mat(1,repState(j)));
   end      
   fprintf(fid, '" \\\\+11 \n');         
   
   % -- Bond Real-- %
   fprintf(fid, '" ');
   fprintf(fid, '~~Real Bond');
   for j=1:numState+1
      fprintf(fid, ' " %4.2f ', Ealpha_rbond_mat(1,repState(j)));
   end      
   fprintf(fid, '" \\\\+11 \n');         

   % -- Bond Nominal -- %
   fprintf(fid, '" ');
   fprintf(fid, '~~Nominal Bond');
   for j=1:numState+1
      fprintf(fid, ' " %4.2f ', Ealpha_nbond_mat(1,repState(j)));
   end      
   fprintf(fid, '" \\\\+11 \n');         

   % -- Cash -- %
   fprintf(fid, '" ');
   fprintf(fid, '~~Cash');
   for j=1:numState+1
      fprintf(fid, ' " %4.2f ', Cash_mat(1,repState(j)));
   end      
   fprintf(fid, '" \\\\+15 \\_1 \n'); 
   
load(File4);		% Annual data.

	% ---- Gamma = HI ---- %
if psiID == 1
	if AQ == 'A'
		paramstr = strcat('" \\use3 \\L $~\\gamma = ',num2str(gamavec),', \\psi = 1, \\rho = ',num2str(rhovec),'  $ " \\\\+34 \n');
	else
		paramstr = strcat('" \\use3 \\L $~\\gamma = ',num2str(gamavec),', \\psi = 1, \\rho = ',num2str(rhovec^4),'^{1/4}  $ " \\\\+34 \n');
	end
else
	if AQ == 'A'
		paramstr = strcat('" \\use3 \\L $~\\gamma = ',num2str(gamavec),', \\psi = 1/\\gamma, \\rho = ',num2str(rhovec),'  $ " \\\\+34 \n');
	else
		paramstr = strcat('" \\use3 \\L $~\\gamma = ',num2str(gamavec),', \\psi = 1/\\gamma, \\rho = ',num2str(rhovec^4),'^{1/4}  $ " \\\\+34 \n');
	end
end

   fprintf(fid, paramstr);
   
   % -- Stock -- %
   fprintf(fid, '" ');
   fprintf(fid, '~~Stock');
   for j=1:numState+1
      fprintf(fid, ' " %4.2f ', Ealpha_stock_mat(1,repState(j)));
   end      
   fprintf(fid, '" \\\\+11 \n');         
   
   % -- Bond Real-- %
   fprintf(fid, '" ');
   fprintf(fid, '~~Real Bond');
   for j=1:numState+1
      fprintf(fid, ' " %4.2f ', Ealpha_rbond_mat(1,repState(j)));
   end      
   fprintf(fid, '" \\\\+11 \n');         

   % -- Bond Nominal -- %
   fprintf(fid, '" ');
   fprintf(fid, '~~Nominal Bond');
   for j=1:numState+1
      fprintf(fid, ' " %4.2f ', Ealpha_nbond_mat(1,repState(j)));
   end      
   fprintf(fid, '" \\\\+11 \n');         

   % -- Cash -- %
   fprintf(fid, '" ');
   fprintf(fid, '~~Cash');
   for j=1:numState+1
      fprintf(fid, ' " %4.2f ', Cash_mat(1,repState(j)));
   end      
   fprintf(fid, '" \\\\+15 \\_1 \n'); 

load(File5);		% Annual data.

	% ---- Gamma = HI ---- %
if psiID == 1
	if AQ == 'A'
		paramstr = strcat('" \\use3 \\L $~\\gamma = ',num2str(gamavec),', \\psi = 1, \\rho = ',num2str(rhovec),'  $ " \\\\+34 \n');
	else
		paramstr = strcat('" \\use3 \\L $~\\gamma = ',num2str(gamavec),', \\psi = 1, \\rho = ',num2str(rhovec^4),'^{1/4}  $ " \\\\+34 \n');
	end
else
	if AQ == 'A'
		paramstr = strcat('" \\use3 \\L $~\\gamma = ',num2str(gamavec),', \\psi = 1/\\gamma, \\rho = ',num2str(rhovec),'  $ " \\\\+34 \n');
	else
		paramstr = strcat('" \\use3 \\L $~\\gamma = ',num2str(gamavec),', \\psi = 1/\\gamma, \\rho = ',num2str(rhovec^4),'^{1/4}  $ " \\\\+34 \n');
	end
end

   fprintf(fid, paramstr);
   
   % -- Stock -- %
   fprintf(fid, '" ');
   fprintf(fid, '~~Stock');
   for j=1:numState+1
      fprintf(fid, ' " %4.2f ', Ealpha_stock_mat(1,repState(j)));
   end      
   fprintf(fid, '" \\\\+11 \n');         
   
   % -- Bond Real-- %
   fprintf(fid, '" ');
   fprintf(fid, '~~Real Bond');
   for j=1:numState+1
      fprintf(fid, ' " %4.2f ', Ealpha_rbond_mat(1,repState(j)));
   end      
   fprintf(fid, '" \\\\+11 \n');         

   % -- Bond Nominal -- %
   fprintf(fid, '" ');
   fprintf(fid, '~~Nominal Bond');
   for j=1:numState+1
      fprintf(fid, ' " %4.2f ', Ealpha_nbond_mat(1,repState(j)));
   end      
   fprintf(fid, '" \\\\+11 \n');         

   % -- Cash -- %
   fprintf(fid, '" ');
   fprintf(fid, '~~Cash');
   for j=1:numState+1
      fprintf(fid, ' " %4.2f ', Cash_mat(1,repState(j)));
   end      
   fprintf(fid, '" \\\\+15 \\_1 \n'); 

      
% -- Finish Tex Table Format -- %
fprintf(fid, '\\EndTable \n');

fprintf(fid, '\\bigskip \\footnotesize{\\bf Note}: $AR_t$ = real returns on T-Bills, excess return on ');
fprintf(fid, 'stocks, and excess return on bonds; $y_t$ = nominal yield on T-Bills; $(d-p)_t$ = log ');
fprintf(fid, 'dividend-price ratio; $spr_t$ = yield spread. The bond is a 5-year nominal bond in the ');
fprintf(fid, 'quarterly dataset and a 20-year in the annual dataset. \\normalsize ');

fprintf(fid, '\\end{document} \n');
status = fclose(fid);
