% ---- Create Latex Tables for the VAR Estimatioin: Quarterly, full and late sample ---- %
% -- User Specifies Info Here -- %
TableDir  = './tables/';
File1 	= 'ISV_A_g0001_pID1_SNR';	% quarterly
TableName = 'Table_VAR_A_SNR.tex';
%File1 	= 'VAR_A_g0001_pID1_SNR';	% quarterly
%TableName = 'Table_VAR_A_SNR.tex';


% -- Create Latex Shell -- %
extTableName = [TableDir, TableName];
fid = fopen(extTableName,'w');
fprintf(fid, '\\documentstyle{article} \n');
fprintf(fid, '\\setlength{\\oddsidemargin}{.25in} \n');
fprintf(fid, '\\setlength{\\textwidth}{5.5in} \n');
fprintf(fid, '\\setlength{\\topmargin}{0.50in} \n');
fprintf(fid, '\\setlength{\\textheight}{9.00in} \n');
fprintf(fid, '\\pagestyle{empty} \n');
fprintf(fid, '\\begin{document} \n');
fprintf(fid, '\\input table \n');
fprintf(fid, '\\BeginTable \n');
fprintf(fid, '\n');
fprintf(fid, '\\def\\C{\\JustCenter} \n');
fprintf(fid, '\\def\\L{\\JustLeft} \n');
fprintf(fid, '\\def\\R{\\JustRight} \n');
%fprintf(fid, '\\Expand \n');

% -- Full Sample Results -- %
load(File1);
CORRv = CorrResid;

signifr2; %should already be run in main.m -- just here as backup.

	numState = cols(dataOUT);
	nameState = char('~~$rtb_{t+1}$', '~~$xr_{t+1}$', '~~$xnb_{t+1}$', '~~$xrcb_{t+1}$', '~~$y_{t+1}$', '~~$(d-p)_{t+1}$', '~~$spr_{t+1}$');
   
   fprintf(fid, '\\BeginFormat \n');
   fprintf(fid, '|   l   | cn[-0.000] |  cn[-0.000] | cn[-0.000] | cn[-0.000] | cn[-0.000] | cn[-0.000] | cn[-0.000] | cn[-0.000] | \n');
   fprintf(fid, '\\EndFormat \n');
   
   fprintf(fid, '" \\use9 \\C \\bf TABLE 2 " \\\\+02 \n');
   fprintf(fid, '" \\use9 \\C \\bf VAR Estimation Results " \\\\+13 \\_3 \n');
   
   fprintf(fid, '" \\C Dependent " \\C $rtb_t$ " \\C $xr_t$ " \\C $xnb_t$ " \\C $xrcb_t$ " \\C $y_t$ " \\C $(d-p)_t$  " \\C $spr_t$ " \\C  $R^2$ " \\\\+20 \n');
   fprintf(fid, '" \\C Variable  " \\C  $(t)$  " \\C  $(t)$ " \\C  $(t)$ " \\C  $(t)$ " \\C  $(t)$    " \\C  $(t)$   " \\C  $(t)$ " \\C $(p)$ " \\\\+13 \\_2 \n');
   
   fprintf(fid, '" \\use4 \\L VAR Estimation Results " {} " {} " {} " {} " {} " \\\\+33 \n');


   for i=1:numState
      % -- Print out Coefficients -- %
      fprintf(fid, '" ');
      fprintf(fid, nameState(i,:));
      for j=1:numState
         fprintf(fid, ' " %4.3f ', PHI1(i,j));
      end
      
      % -- Print out R^2 -- %
      fprintf(fid, '" %1.3f ', Rsqvec(i));
      fprintf(fid, '" \\\\+11 \n');
      
      % -- Print out Standard Errors -- %
      fprintf(fid, '" {} '); 
      for j=1:numState
         fprintf(fid, '" (%4.3f) ', tPHI1(i,j));
      end

      % -- Print out p value for indiv. regression -- %
      fprintf(fid, '" (%1.3f) ', pvals(i));
      fprintf(fid, '" \\\\+14 \n');
      
   end
	   
   fprintf(fid, '\\\\+10 \\_3 \n');   
     
% -- SubSample Results -- %
   
   fprintf(fid, '" \\use4 \\L Cross-Correlation of Residuals " {} " {} " {} " {} " {} " \\\\+33 \n');
   fprintf(fid, '" \\C           " \\C $rtb$    " \\C $xr$ " \\C $xnb$ " \\C $xrcb$ " \\C $y$ " \\C $(d-p)$   " \\C $spr$ "  {}       " \\\\+20 \n');


   for i=1:numState
      % -- Print out Coefficients -- %
      fprintf(fid, '" ');
         astr = deblank(nameState(i,:));
      fprintf(fid, strcat(astr(1:cols(astr)-7),'$'));
      for j=1:numState
		if j >= i
			if j == i
				% diagonal is annualized standard deviation
				% in percentage terms
				AA = sqrt(diag(SIGMAv));
				fprintf(fid, ' " %4.3f ', AA(i)*100);
			else
				fprintf(fid, ' " %4.3f ', CORRv(i,j));
			end
		else
			fprintf(fid, ' " - ');
		end			
      end
      
% fill in last column
      fprintf(fid, '" {} ');
      fprintf(fid, '" \\\\+11 \n');
      
   end
	   
   fprintf(fid, '\\\\+10 \\_3 \n');   
   

% -- Finish Tex Table Format -- %
fprintf(fid, '\\EndTable \n');

fprintf(fid, '\\bigskip \\footnotesize{\\bf Note}: $rtb_t$ = ex post real T-Bill rate, $xr_t$ = excess stock return, ');
fprintf(fid, '$xrcb_t$ = excess real consol bond return, $(d-p)_t$ = log dividend-price ratio, $y_t$ = nominal T-bill yield, ');
fprintf(fid, '$xnb_t$ = excess nominal long bond return, ');
fprintf(fid, '$spr_t$ = yield spread. The bond is a 5-year nominal bond in the quarterly dataset and a 20-year for the annual dataset. \\normalsize ');

fprintf(fid, '\\end{document} \n');
status = fclose(fid);
