% ---- Create Latex Tables for the Variance Decomposition: Gamma = 5  ---- %

% -- User Specifies Info Here -- %
TableDir  = './tables/';


% -- Create Latex Shell -- %
ExtTableName = [TableDir, TableName];
fid = fopen(ExtTableName,'w');
fprintf(fid, '\\documentstyle{article} \n');
fprintf(fid, '\\setlength{\\oddsidemargin}{.25in} \n');
fprintf(fid, '\\setlength{\\textwidth}{10in} \n');
fprintf(fid, '\\setlength{\\topmargin}{0.50in} \n');
fprintf(fid, '\\setlength{\\textheight}{6.50in} \n');
fprintf(fid, '\\pagestyle{empty} \n');
fprintf(fid, '\\begin{document} \n');
fprintf(fid, '\\input table \n');
fprintf(fid, '\\BeginTable \n');
fprintf(fid, '\n');
fprintf(fid, '\\def\\C{\\JustCenter} \n');
fprintf(fid, '\\def\\L{\\JustLeft} \n');
fprintf(fid, '\\def\\R{\\JustRight} \n');
%fprintf(fid, '\\Expand \n');

% -- Full Sample Results -- %
%load(File1);

	numState = cols(H1);
	nameState = char('~~$rtb_{t}$', '~~$xr_{t}$', '~~$xb_{t}$','~~$y_{t}$', '~~$(d-p)_{t}$', '~~$spr_{t}$');
   
   fprintf(fid, '\\BeginFormat \n');
   fprintf(fid, '|    l  | cn[-0.0] |cn[-0.0] | cn[-0.0] | cn[-0.0] | cn[-0.0] | cn[-0.0] | cn[-0.0] |cn[-0.0] | cn[-0.0] |cn[-0.0] |cn[-0.0] |cn[-0.0] |  \n');
%   fprintf(fid, '|    l  | cn[-0.0] | cn[-0.0] | cn[-0.0] | cn[-0.0] | cn[-0.0] | cn[-0.0] |cn[-0.0] | cn[-0.0] | cn[-0.0] | cn[-0.0] | cn[-0.0] | cn[-0.0] |cn[-0.0] | cn[-0.0] | cn[-0.0] | cn[-0.0] | cn[-0.0] | cn[-0.0] |cn[-0.0] | cn[-0.0] |  \n');
   fprintf(fid, '\\EndFormat \n');

   fprintf(fid, '" \\use3 {} " \\use7 \\C \\bf TABLE " \\use3 {} " \\\\+02 \n');
   fprintf(fid, '" \\use3 {} " \\use7 \\C \\bf Variance Decomposition of Asset Demands " \\use3 {} " \\\\+13  \n');
   fprintf(fid, '" \\use3 {} " \\use7 \\C Panel A: 1952Q2 - 1997Q4 " \\use3 {} " \\\\+15 \\_3 \n');


   
   fprintf(fid, '" \\use3 {} " \\use7 \\C  $\\gamma = 5, \\psi = 1, \\rho = 0.92^{1/4}$ " \\use3 {} " \\\\+25  \n');

   
   fprintf(fid, '" \\use2 {} " \\use3 \\C Var($\\alpha^m$)/Var($\\alpha$) ~(\\%%) " \\use3 \\C Var($\\alpha^h$)/Var($\\alpha$) ~(\\%%) " \\use4 \\C Cov($\\alpha^m, \\alpha^h$)/Var($\\alpha$) ~(\\%%) " \\use1 {} "\\\\+12 \n');


   fprintf(fid, '" \\use2 {} " \\use3 \\- " \\use3 \\- " \\use4 \\- " \\use1 {} " \\\\0 \n');




   fprintf(fid, '" \\use2 Stock " \\use3 %6.2f " \\use3 %6.2f " \\use4 %6.2f ', FractionStockMyopic, FractionStockHedging, FractionStockCov);
   fprintf(fid, '" \\use1 {} " \\\\+22 \n');
   fprintf(fid, '" \\use2 Bond " \\use3 %6.2f " \\use3 %6.2f " \\use4 %6.2f ', FractionBondMyopic, FractionBondHedging, FractionBondCov);
   fprintf(fid, '" \\use1 {} " \\\\+27 \n');

   
   
   fprintf(fid, '" \\use2 {} " \\use9 \\C Percentage of Total Variation Explained By: " \\use2 {} "  \\\\+12 \\_2 \n');
  
   
   % -- Stock -- %
   fprintf(fid, '" \\L Stock " \\use6 {} " \\use4 {} " \\use2 {} " \\\\+33 \n');
   fprintf(fid, '" \\use2 {} " \\C $rtb_t$    " \\C $xr_t$ " \\C $xb_t$ " \\C $y_t$ " \\C $(d-p)_t$  " \\C $spr_t$ " \\use5 {} " \\\\+23 \n');

   
   for i=1:numState
      % -- Print out Fractions of Variance-Covariances -- %
      fprintf(fid, '" ');
      fprintf(fid, nameState(i,:));
      fprintf(fid, '" {} ');
      for j=1:numState
         fprintf(fid, ' " %4.2f ', VarDecompStock(i,j));
      end
      fprintf(fid, '" {} ');
      fprintf(fid, '" {} ');
      fprintf(fid, '" {} ');
      fprintf(fid, '" {} ');
      fprintf(fid, '" {} ');

   	fprintf(fid, '" \\\\+13 \n');         
   end
   fprintf(fid, '\\\\+10 \\_2 \n');   


   
   % -- Bond -- %
   fprintf(fid, '" \\L Bond " \\use6 {} " \\use4 {} " \\use2 {} " \\\\+33 \n');
   for i=1:numState
      % -- Print out Fractions of Variance-Covariances -- %
      fprintf(fid, '" ');
      fprintf(fid, nameState(i,:));
      fprintf(fid, '" {} ');
      for j=1:numState
         fprintf(fid, ' " %4.2f ', VarDecompBond(i,j));
      end
      fprintf(fid, '" {} ');
      fprintf(fid, '" {} ');
      fprintf(fid, '" {} ');
      fprintf(fid, '" {} ');
      fprintf(fid, '" {} ');

      fprintf(fid, '" \\\\+13 \n');         
   end
	   
   fprintf(fid, '\\\\+10 \\_2 \n');
   

if 0   
end

% -- Finish Tex Table Format -- %
fprintf(fid, '\\EndTable \n');

fprintf(fid, '\\bigskip \\footnotesize{\\bf Note}: $rtb_t$ = ex post real T-Bill rate, $xr_t$ = excess stock return, ');
fprintf(fid, '$xb_t$ = excess bond return, $(d-p)_t$ = log dividend-price ratio, $rb_t$ = relative bill rate, ');
fprintf(fid, '$spr_t$ = yield spread. The bond is a 5-year nominal bond in the monthly dataset and a 20-year in the annual dataset. \\normalsize ');

fprintf(fid, '\\end{document} \n');
status = fclose(fid);
