	if AQ == 'Q'
		load ISV_Q_g0005_pID1_SN__s.mat
	else      
		load ISV_A_g0005_pID1_SN__s.mat
	end

[PHI0,PHI1,tPHI0,tPHI1,SIGMAv,Rsqvec,CORRv] = GetParms_res(dataOUT,1,0,1);
muState = inv(eye(rows(PHI0)) - PHI1)*PHI0;
sigmaState = reshape(inv(eye((rows(PHI1))^2)-kron(PHI1,PHI1))*SIGMAv(:),rows(PHI0),rows(PHI0));

% -- Initialize Matrices -- %
ECW_mat     = [0,rhovec'; gamavec,zeros(rows(gamavec), rows(rhovec))];
ImpliedDelta_psi1_mat = [0,rhovec'; gamavec,zeros(rows(gamavec), rows(rhovec))];
ImpliedDelta_mat = [0,rhovec'; gamavec,zeros(rows(gamavec), rows(rhovec))];
volcg_mat   = [0,rhovec'; gamavec,zeros(rows(gamavec), rows(rhovec))];
Ealpha_stock_mat = [0,rhovec'; gamavec,zeros(rows(gamavec), rows(rhovec))];
Ealpha_bond_mat = [0,rhovec'; gamavec,zeros(rows(gamavec), rows(rhovec))];
Cash_mat = [0,rhovec'; gamavec,zeros(rows(gamavec), rows(rhovec))];
myopicD_stock_mat = [0,rhovec'; gamavec,zeros(rows(gamavec), rows(rhovec))];
myopicD_bond_mat = [0,rhovec'; gamavec,zeros(rows(gamavec), rows(rhovec))];
hedgeD_stock_mat = [0,rhovec'; gamavec,zeros(rows(gamavec), rows(rhovec))];
hedgeD_bond_mat = [0,rhovec'; gamavec,zeros(rows(gamavec), rows(rhovec))];
HedgeRatio_stock_mat = [0,rhovec'; gamavec,zeros(rows(gamavec), rows(rhovec))];
HedgeRatio_bond_mat = [0,rhovec'; gamavec,zeros(rows(gamavec), rows(rhovec))];
E_rp_mat = [0,rhovec'; gamavec,zeros(rows(gamavec), rows(rhovec))];
vol_rp_mat = [0,rhovec'; gamavec,zeros(rows(gamavec), rows(rhovec))];

% -- Implied Delta when psi = 1 so that delta = rho -- %
ImpliedDelta_psi1_mat = kron(ones(rows(gamavec),1), rhovec');
ImpliedDelta_psi1_mat = [0,rhovec'; gamavec, ImpliedDelta_psi1_mat ];

% -- Initialize Matrices for Variance Decomposition of Asset Demand -- %
VarDecompStock = zeros(rows(muState),rows(muState));
VarDecompStockMyopic = zeros(rows(muState),rows(muState));
VarDecompStockHedging = zeros(rows(muState),rows(muState));
VarDecompBond  = zeros(rows(muState),rows(muState));
VarDecompBondMyopic  = zeros(rows(muState),rows(muState));
VarDecompBondHedging  = zeros(rows(muState),rows(muState));

% ---- Calculations ---- %
      %%%% ---- Compute Various Statistics/Results, e.g. E(c-w) ---- %%%%
     	ComputeStatistics;
      VarianceDecompose;
        
    	% -- Report Results -- %
     	if SysId == 1
        	VAR1Display2;
     	elseif SysId == 2
        	VAR2Display2;
     	end;
            
     	% -- Restore Results -- %
     	ECW_mat(i+1,j+1)     = ECW;
		%EV_mat(i+1,j+1)      = EV;
      volcg_mat(i+1,j+1)   = volcg;

      Ealpha_stock_mat(i+1,j+1)  = Ealpha(1);
      Ealpha_bond_mat(i+1,j+1)   = Ealpha(2);
      Cash_mat(i+1,j+1) 			= 100 - (Ealpha(1)+Ealpha(2));
      myopicD_stock_mat(i+1,j+1) = myopicD(1);
    	myopicD_bond_mat(i+1,j+1)  = myopicD(2);
     	hedgeD_stock_mat(i+1,j+1)  = hedgeD(1);
     	hedgeD_bond_mat(i+1,j+1)   = hedgeD(2);
     	HedgeRatio_stock_mat(i+1,j+1) = HedgeRatio(1);
      HedgeRatio_bond_mat(i+1,j+1)  = HedgeRatio(2);
   
      E_rp_mat(i+1,j+1) = E_rp;
      vol_rp_mat(i+1,j+1) = vol_rp;
                                         


