%processtotex.m
%Purpose is to translate the asset allocations generated in InflStateVar_general.m and
%translate them into variables used by the TexTable_ISV*.m files.  Note that 
%TexTable_ISV*.m files are only written for three possible asset combinations (and for
%specific sets of state variables -- see batch and uberbatch for which combinations
%are actually used.

if sum(AU == 'SNR')==3
	Ealpha_stock_mat = Ealpha_mat(1,:);
	Ealpha_nbond_mat = Ealpha_mat(2,:);
	Ealpha_rbond_mat = Ealpha_mat(3,:);
	Cash_mat = 100 - sum(Ealpha_mat)
	hedgeD_stock_mat  = hedgeD_mat(1,:);
	hedgeD_nbond_mat  = hedgeD_mat(2,:);
	hedgeD_rbond_mat  = hedgeD_mat(3,:);
	hedgeD_cash_mat  = 0-sum(hedgeD_mat);
elseif sum(AU == 'SN_')==3
	Ealpha_stock_mat = Ealpha_mat(1,:);
	Ealpha_bond_mat = Ealpha_mat(2,:);
	Cash_mat = 100 - sum(Ealpha_mat)
	hedgeD_stock_mat  = hedgeD_mat(1,:);
	hedgeD_bond_mat  = hedgeD_mat(2,:);
	hedgeD_cash_mat  = 0-sum(hedgeD_mat);
elseif sum(AU == 'SR_')==3
	Ealpha_stock_mat = Ealpha_mat(1,:);
	Ealpha_bond_mat = Ealpha_mat(2,:);
	Cash_mat = 100 - sum(Ealpha_mat)
	hedgeD_stock_mat  = hedgeD_mat(1,:);
	hedgeD_bond_mat  = hedgeD_mat(2,:);
	hedgeD_cash_mat  = 0-sum(hedgeD_mat);
else
	fprintf(['No TeX output implemented for asset combination ' AU]);
	disp('.');
end
